!function(e,t){"function"==typeof define?define("BasthonBase",["module"],t):"object"==typeof exports?module.exports=t():e.BasthonBase=t()}(this,function(t){"use strict";function r(e){this.message=`Function ${e} not implemented!`}return class{constructor(){this.__version__="0.30.4",this._urlScript=function(){let e=window.location.origin+window.location.pathname;return e=e.substring(0,e.lastIndexOf("/"))+"/",null!=window.BASTHON_KERNEL_SCRIPT?e+window.BASTHON_KERNEL_SCRIPT:null!=t?e+t.uri:document.currentScript.src}()}version(){return this.__version__}language(){throw new r("language")}languageName(){throw new r("languageName")}moduleExts(){throw new r("moduleExts")}async launch(){throw new r("launch")}evalAsync(e,t,n,o=0){throw new r("evalAsync")}restart(){throw new r("restart")}putFile(e,t){throw new r("putFile")}putModule(e,t){throw new r("putModule")}userModules(){throw new r("userModules")}getFile(e){throw new r("getFile")}getUserModuleFile(e){throw new r("getUserModuleFile")}more(e){throw new r("more")}complete(e){return[]}banner(){return`Welcome to the ${this.languageName()} REPL!`}ps1(){return">>> "}ps2(){return"... "}init(){const e=this;return this._loaded=this.launch().then(function(){e.addEventListener("eval.request",e.evalFromEvent.bind(e))})}loaded(){return this._loaded||this.init()}urlScript(){return this._urlScript}dirname(e){return e.substring(0,e.lastIndexOf("/"))}basthonRoot(){return this.dirname(this.urlScript())+"/"+this.version()}download(e,t){e=new Blob([e],{type:"application/octet-stream"});let n=document.createElement("a");n.download=t,n.href=window.URL.createObjectURL(e),n.target="_blank",n.style.display="none",document.body.appendChild(n),n.click(),document.body.removeChild(n)}loadScript(o){return new Promise(function(e,t){let n=document.createElement("script");n.onload=e,n.onerror=t,n.src=o,document.head.appendChild(n)})}pageLoad(){return this._pageLoad||(this._pageLoad=new Promise(function(e,t){"complete"===document.readyState?e():window.addEventListener("load",function(){window.removeEventListener("load",this),e()})}))}xhr(t){const n=new XMLHttpRequest;n.open(t.method,t.url,!0),null!=t.responseType&&(n.responseType=t.responseType);var e=new Promise(function(e,t){n.onload=function(){200<=n.status&&n.status<300?e(n.response):t(n)},n.onerror=function(){t(n)}});t.headers&&Object.keys(t.headers).forEach(function(e){n.setRequestHeader(e,t.headers[e])});let o=t.data;return o&&"object"==typeof o&&(o=JSON.stringify(o)),n.send(o),e}dispatchEvent(e,t){t=new CustomEvent("basthon."+e,{detail:t});document.dispatchEvent(t)}addEventListener(e,t){document.addEventListener("basthon."+e,function(e){t(e.detail)})}clone(e){return JSON.parse(JSON.stringify(e))}putRessource(e,t){var n=e.split(".").pop();return this.moduleExts().includes(n)?this.putModule(e,t):this.putFile(e,t)}evalFromEvent(o){const r=this;function e(n){return function(e){let t=r.clone(o);t.stream=n,t.content=e,r.dispatchEvent("eval.output",t)}}var t=e("stdout");let n=e("stderr");return r.evalAsync(o.code,t,n,o).then(function(e){var t=e[0],e=e[1];let n=r.clone(o);n.execution_count=e,void 0!==t&&(n.result=t),r.dispatchEvent("eval.finished",n)},function(e){n(e.toString());let t=r.clone(o);t.error=e,t.execution_count=r.execution_count,r.dispatchEvent("eval.error",t)})}}});
!function(t,e){"function"==typeof define?define("Basthon",["BasthonBase"],e):"object"==typeof exports?module.exports=e():t.Basthon=e(BasthonBase)}(this,function(t){"use strict";class e extends t{constructor(){super(),this.execution_count=0,this._sqlJsUrl="https://cdnjs.cloudflare.com/ajax/libs/sql.js/1.5.0/sql-wasm.min.js"}language(){return"sql"}languageName(){return"SQL"}moduleExts(){return["sql","db","sqlite"]}async launch(){try{"undefined"!=typeof requirejs?(requirejs.config({paths:{"sql-wasm":this._sqlJsUrl.slice(0,-3)}}),await new Promise(function(t,e){require(["sql-wasm"],t,e)})):await this.loadScript(this._sqlJsUrl)}catch(t){console.log(t),console.error("Can't load sql.js")}const t=await window.initSqlJs({locateFile:t=>`https://sql.js.org/dist/${t}`});this.db=new t.Database,await this.pageLoad()}troncate_table(t){if(150<=t.values.length){var e=Math.floor(50);const s=t.values.slice(0,e);e=t.values.slice(-e);t.values=s.concat([t.columns.map(()=>"⋮ ")],e)}}html_table(t){return this.troncate_table(t),`<table class="dataframe" border="1">${`<thead><tr style="text-align: right;">${t.columns.map(t=>`<th>${t}</th>`).join("")}</tr></thead>`}${`<tbody>${t.values.map(t=>"<tr>"+t.map(t=>`<td>${t}</td>`).join("")+"</tr>").join("")}</tbody>`}</table>`}text_table(t){return this.troncate_table(t),`${t.columns.join("\t")}\n${t.values.map(t=>t.join("\t")).join("\n")}`}async evalAsync(t,e,s,a=null){a.interactive=!0,this.execution_count++;let n=this.db.exec(t);return void 0!==n&&(n=0==n.length?void 0:{"text/plain":this.text_table(n[0]),"text/html":this.html_table(n[0])}),[n,this.execution_count]}ps1(){return"sql> "}ps2(){return"...> "}restart(){this.db&&this.db.close(),this.execution_count=0,this.db=new SQL.Database}more(t){return!1}complete(t){return[]}putFile(t,e){console.error(`Fichier ${t} not added since putFile has no mean in the SQL context.`)}putModule(t,e){switch(t.split("/").pop()){case"sql":this.db.run(e);break;case"sqlite":case"db":this.db&&this.db.close(),this.db=new SQL.Database(e);break;default:throw{message:"Only '.sql', '.db' and '.sqlite' files supported."}}}}return new e});
!function(e,t){"function"==typeof define?define("BasthonGoodies",["Basthon"],t):"object"==typeof exports?module.exports=t():e.Basthon.Goodies=t(e.Basthon)}(this,function(a){"use strict";let l={loaderId:"basthon-loader",showLoader:async function(e,t=!0){a.init();const o=document.createElement("div");o.id=l.loaderId,o.style.cssText=`
            position: fixed;
            display: block;
            top: 0px;
            left: 0px;
            width: 100%;
            height: 100%;
            background-color: rgba(0, 0, 0, 0.65);
            text-align: center;
            display: flex;
            justify-content: center;
            align-items: center;
            z-index: 2000;`;const n=document.createElement("div");n.style.cssText=`
            display: flex;
            justify-content: center;
            align-items: center;
            flex-wrap: wrap;
            width: 100%;`,o.appendChild(n);const i=document.createElement("div");i.style.cssText=`
            position: relative;
            border: 16px solid #fcc24a;
            border-top: 16px solid #3b749c;
            border-bottom: 16px solid #3b749c;
            border-radius: 50%;
            width: 120px;
            height: 120px;
            animation: spin 2s linear infinite;
            overflow: auto;
            opacity: 0.8;`,n.appendChild(i);let d=document.createElement("div");d.style.cssText=`
            flex-basis: 100%;
            height: 20px;`,n.appendChild(d);let r=document.createElement("div");r.innerHTML=e,r.style.cssText="color: white;",n.appendChild(r),l._loaderTextElem=r;const s=document.createElement("style");document.head.appendChild(s),s.sheet.insertRule(`
        @keyframes spin {
            0% { transform: rotate(0deg); }
            100% { transform: rotate(360deg); }
        }`),document.body.appendChild(o),l._rootLoader=o,await a.loaded(),t&&l.hideLoader()},setLoaderText:function(e){l._loaderTextElem.innerHTML=e},hideLoader:function(){var e=l._rootLoader;const t=Array.prototype.slice.call(e.children);t.push(e),t.forEach(function(e){e.style.display="none"})}};return l});
//# sourceMappingURL=basthon-sql.min.js.map
